# -*- coding: utf-8 -*-
from setuphelpers import *
import msilib
import json

def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    url_api = "http://omahaproxy.appspot.com/all.json?os=win64&channel=stable"
    url_dl = "https://dl.google.com/tag/s/dl/chrome/install/googlechromestandaloneenterprise64.msi"

    # Getting latest informations from official Google API
    json_load = json.loads(wgets(url_api, proxies=proxies))
    version = json_load[0]["versions"][0]["version"]
    latest_bin = "googlechromestandaloneenterprise64_%s.msi" % version

    print("Latest %s version is: %s" % (app_name, version))
    print("Download url is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: " + latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)

        # Get version from description msi
        db = msilib.OpenDatabase(latest_bin, msilib.MSIDBOPEN_READONLY)
        db.GetSummaryInformation(1)
        description = db.GetSummaryInformation(1).GetProperty(6)
        msiversion = ensure_unicode(description).split(" ", 1)[0]

        if msiversion != version:
            remove_file(latest_bin)
            error("The version returned by the API and the version returned by the msi does not match")

    # Changing version of the package
    if Version(version) > control.get_software_version():
        print("Software version updated from: %s to: %s" % (control.get_software_version(), Version(version)))
        result = True
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(Version(version))
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating update-package-sources
    return result